function y=entropy_pdf(x)
% Usage: y=entropy(x)
% compute the entropy of a probability vector x
% each element of x must be non-negative, and sum(x)=1
% (C) 2006 by Yu Hen Hu
% created: Dec. 19. 2006

if min(x) < 0, error('x must contain non-negative entries only!'); end
% normalize x such that sum(x)=1
% x=[0 2 4 8 2 3 0 4]
x=x/sum(x);

%Remove zero value for log2(0) = undefined
idx = x==0;
x(idx)=[];
y=-sum(x.*log2(x));

% %eps Added by me
% y=-sum(x.*log2(x+eps));
